package mbgw3

import (
  "log"
  //"reflect"
  //"time"
  "strconv"
  "encoding/json"
  "udi/handlers/handler"
  "udi/database"
)


var idSeq int = 0

type Mbgw3Handler struct {
  id int
  dbh *database.DatabaseHandle
}

type Observation struct {
  Status string `json:"Status"`
  RequestId string `json:"RequestId"`
  Device string `json:"Device"`
  Errors string `json:"Errors"`
  Requests string `json:"Requests"`
  Values map[string]string
}


func NewMbgw3Handler() *Mbgw3Handler {
  t := &Mbgw3Handler {
    id: idSeq,
  }
  idSeq += 1

  t.dbh = database.NewDatabaseHandle("")
  return t
}

func (self *Mbgw3Handler) Handle(message handler.MessageT) {
  log.Printf("Handler MBGW3 %d processing %s -> %s", self.id, message.Topic, message.Payload)

  var observation Observation
  err := json.Unmarshal([]byte(message.Payload), &observation)
  if err != nil {
    log.Printf("Unable to parse payload into Observation struct, values are lost: ", err)
    return
  }
  log.Printf("Parsed observation: %s", observation)

  attributes := make(map[string]string
  if v, err := strconv.Atoi(observation.RequestId), err == nil {
    attributes["RequestId"] = v
  }

  attributes["Errors"] = observation.Errors
  attributes["Requests"] = observation.Requests

  /*
  variables := make(map[string]database.VariableType)
  pvValueStructValue := reflect.ValueOf(pvValue)
  for i := 0; i < pvValueStructValue.NumField(); i++ {
    field := pvValueStructValue.Type().Field(i)
    fieldValue := pvValueStructValue.Field(i)
    v := database.VariableType {
      Label: "",
      Variable: field.Name,
      Unit: field.Tag.Get("unit"),
      Value: fieldValue.Interface(),
    }
    variables[field.Name] = v
  }

  measurement := database.Measurement {
    Time: time.Now(),
    Application: "PV",
    Device: "Powermeter",
    Values: variables,
  }

  self.dbh.StoreMeasurement(&measurement)
  */
}


